/**
 * Created by Administrator on 2016/5/13.
 */
// 简单的移动,并不以A*算法的移动
var ActionMove = Action.extend({

    // 移动速度
    moveSeep:null,
    // 下次要移动的场景点
    moveScenePoint:null,
    // 移动的间隔大小
    moveStepPoint:null,
    // 当前移动速度
    nowMoveSeep:null,

    // 设置默认值
    ctor:function ()
    {
        this._super();
        this.skinType = moveSkinType;
        this.actionType = moveActionType;
    },

    initialize:function(data)
    {
        this.setMoveInfo(data);
        this._super(data);
    },

    run:function ()
    {
        this.computeMoveSeep(this.getMoveSeep());
    },

    update:function ()
    {
        if(engine.gameTime.isPause)
        {
            return;
        }

        var animal = engineGetElement(this.animalID, this.animalType);
        if(animal != null)
        {
            var dic = cc.pDistance(cc.p(animal.x, animal.y), this.moveScenePoint);

            // 如果变速则需要重新计算
            if(this.nowMoveSeep != this.getMoveSeep())
            {
                this.computeMoveSeep(this.getMoveSeep());
            }
            if(dic < this.getMoveSeep())
            {
                this.moveScenePoint = null;
                this.complete(animal);
            }
            else
            {
                animal.x += this.moveStepPoint.x;
                animal.y += this.moveStepPoint.y;
            }
        }
    },

    // 计算移动速度
    computeMoveSeep:function(seep)
    {
        this.nowMoveSeep = seep;
        var animal = engineGetElement(this.animalID, this.animalType);
        if(animal != null)
        {
            var degree = getAngle(cc.p(animal.x, animal.y), this.moveScenePoint);
            this.moveStepPoint = beginPointTodistance(cc.p(0, 0), degree, this.getMoveSeep());
        }
    },

    getMoveSeep:function()
    {
        return this.moveSeep * gameSeep;
    },

    setMoveInfo:function(data)
    {
        this.moveScenePoint = data.moveScenePoint;
        this.setMoveSeep(data.moveSeep);
    },

    setMoveSeep:function(moveSeep)
    {
        this.moveSeep = moveSeep;
    }
})