
var currentScene = null;

var GameScene = cc.Scene.extend({

    sceneName:null,

    onEnter:function()
    {
        currentScene = this;
        this._super();
    },

    initialize:function()
    {
        this.scheduleUpdate();
    },

    update:function(data)
    {
        engine.engineuUpdate(data);
    }
})

var transitions = function(scene, res, loadScene, analysisFun)
{
    if(res == null)
    {
        res = [];
    }

    if(loadScene == null)
    {
        loadScene = LoadScene;
    }

    loaderRes(res, function ()
    {
        // 转场前释放资源
        // 释放元素
        engine.gameElementManage.cleanGameElementDic();
        // 释放网格
        engine.gameElementManage.cleanGameGridDic();
        // 释放技能
        engine.gameSkillManage.cleanSkill();
        // 释放心跳
        engine.gameUpdate.cleanUpdate();

        cc.director.runScene(new scene());
    }, loadScene, analysisFun);
}