/**
 * Created by Administrator on 2016/10/28.
 */

// 横向3宫格进度条 横着的
var ScaleLandscape3Progress = cc.Sprite.extend({

    // 底部图片
    bottomSprite:null,
    // 左边图片
    leftSprite:null,
    // 右边图片
    rightSprite:null,
    // 中间
    middleSprite:null,

    // 左边宽
    leftSpriteWidth:null,
    // 右边宽
    rightSpriteWidth:null,
    // 中间宽
    middleSpriteWidth:null,
    // 百分比
    percent:null,
    // 最大长度
    maxWidth:null,

    initialize:function(data)
    {
        this.bottomSprite = data.bottomSprite;
        this.leftSprite = data.leftSprite;
        this.rightSprite = data.rightSprite;
        this.middleSprite = data.middleSprite;
        this.rightSprite.setAnchorPoint(cc.p(0, 0.5));
        this.middleSprite.setAnchorPoint(cc.p(0, 0.5));

        this.leftSpriteWidth = data.leftSpriteWidth;
        this.rightSpriteWidth = data.rightSpriteWidth;
        this.middleSpriteWidth = data.middleSpriteWidth;

        this.maxWidth = data.maxWidth;
        this.middleSprite.x = - this.maxWidth / 2;

        if(this.bottomSprite != null)
        {
            this.addChild(this.bottomSprite);
        }

        this.addChild(this.middleSprite);
        this.addChild(this.rightSprite);
    },

    // 设置进度百分比
    setProgress:function(percent)
    {
        if(percent > 1)
        {
            percent = 1;
        }
        this.percent = percent;
        // 设置中间进度
        if(percent < this.rightSpriteWidth / this.maxWidth)
        {
            this.middleSprite.setVisible(false);
        }
        else
        {
            this.middleSprite.setVisible(true);
            this.middleSprite.setScaleX((this.maxWidth / this.middleSpriteWidth) * (percent - this.rightSpriteWidth / this.maxWidth));
        }
        this.rightSprite.x = -this.maxWidth / 2 + this.percent * this.maxWidth - this.rightSpriteWidth - 1;
    }
})
