var Animal = cc.Sprite.extend
({
    // 编号唯一
    animalID:null,
    // 类型
    animalType:null,
    // A*格子
    gridX:null,
    gridY:null,
    // 皮肤
    skin:null,
    // 方位
    dir:null,
    // 行为
    action:null,
    // 最大血量
    maxHP:null,
    // 当前血量
    hp:null,
    //移动速度
    animalSpeed:null,
    //攻击速度
    attackSpeed:null,
    // buff列表
    buffList:null,

    ctor: function ()
    {
        this._super();
    },

    initialize:function(data)
    {
        this.animalID = data.animalID;
        this.animalType = data.animalType;
        this.gridX = data.gridX;
        this.gridY = data.gridY;
        this.maxHP = data.maxHP;
        this.hp = data.hp;
        this.buffList = [];
    },

    dispose:function()
    {
        if(this.skin != null)
        {
            this.skin.dispose();
        }

        if(this.parent != null)
        {
            this.removeFromParent();
        }

        engine.gameElementManage.deleteElement(this.animalID, this.animalType);
    },

    setAction:function(action)
    {

    },

    // 每帧播放动画
    frame:function(frameIndex)
    {

    },

    // 动画播放完成
    frameComplete:function()
    {

    },

    // 获取打击点
    hitPoint:function()
    {
         return this.getPosition();
    },

    setSkin:function()
    {

    },

    addEffect:function(effect, addType)
    {

    },

    addBuff:function(buff)
    {

    }
})