/**
 * Created by Administrator on 2015/12/31.
 */
var LoadControl = cc.Class.extend(
    {
        // 加载完成回调函数
        cb: null,
        // 加载资源
        resources:null,
        // 原始加载的资源
        originalResources:null,
        // 是否初始化
        isInit: null,
        // 加载进度值 总进度值
        loadIndex:null,
        // 加载对象类名
        loadClassName:null,
        // 解析处理
        analysisFun:null,

        // 初始化
        initialize: function (data)
        {
            this.cb = data.cb;
            this.analysisFun = data.analysisFun;
            this.loadClassName = data.loadClassName;
            this.loadIndex = 0;
            var res = [];
            this.originalResources = data.resources;
            var resources = data.resources;
            // 检查资源是否都被加载了
            for(var i = 0; i < resources.length; i++)
            {
                // 如果是声音
                if((resources[i]).indexOf("mp3") >= 0)
                {
                    if (cc.loader.getRes(getUrlByVersion(resources[i])) == null)
                    {
                        res.push(getUrlByVersion(resources[i]));
                    }
                }
                else
                {
                    if (cc.loader.getRes(resources[i]) == null)
                    {
                        var source = resources[i];
                        var index = (resources[i]).indexOf(".plist");

                        // 是否是纹理图片
                        if(index >= 0)
                        {
                            var plistFileName = resources[i];
                            var strs = plistFileName.split("/");
                            var fileName = strs[strs.length - 1];
                            var pngName = (fileName.split("."))[0] + ".png";
                            var filePNGName = plistFileName.substring(0, plistFileName.length - fileName.length) + pngName;

                            if(cc.loader.getRes(filePNGName) != null)
                            {
                                continue;
                            }
                        }
                        res.push(getUrlByVersion(resources[i]));
                    }
                }
            }

            this.resources = res;

            this.load();
        },

        loadEnd:function()
        {
            // 网页版本要去掉版本号
            if(cc.sys.isNative == false)
            {
                // 在调用之前把版本号去掉, 在资源当中留下不带版本号的
                for(var i = 0; i < this.resources.length; i++)
                {
                    var resData = cc.loader.getRes(this.resources[i]);
                    var index = (this.resources[i]).indexOf("?version=");

                    // mp3 解析不能有版本号
                    if((this.resources[i]).indexOf("mp3") <  0)
                    {
                        if(index >= 0)
                        {
                            var key = this.resources[i].substr(0, index);
                            cc.loader.cache[key] = resData;
                        }
                        cc.loader.release(this.resources[i]);
                    }
                }
            }
            if(this.analysisFun != null)
            {
                this.analysisFun();
            }

            if(this.cb != null)
            {
                this.cb();
            }
        },

        load:function()
        {
            if(this.loadIndex >= this.resources.length)
            {
                this.loadEnd();
            }
            else
            {
                var loadMC = new this.loadClassName();
                loadMC.beginLoad(this);
            }
        }
    }
)

var loadSelf=null;
var LoadScene = GameScene.extend({

    // 加载文本
    label:null,
    // 是否初始化
    isInit: null,
    // 加载个数loadCount
    loadCount:null,
    // 加载控制类
    loadControl:null,

    manAnimation:null,
    bar:null,
    bar_tou:null,
    // 设置默认值
    ctor: function ()
    {
        this.sceneName = "LoadScene";
        this.isInit = false;
        this.loadCount = 0;
        this._super();
    },

    beginLoad:function(loadControl)
    {
        this.loadControl = loadControl;
        loadSelf=this;
        cc.director.runScene(this);


        this.setLoadStyle();
        this.showLoad();
    },
    addPetAction: function(){
        //var res = ["res/csi/role.plist", "res/csi/role.png"];
        //cc.loader.load(res, function(err){
        //    if(err) return console.log("load file");
        //    cc.spriteFrameCache.addSpriteFrames(res[0]);
        //    var index = this.loadControl.loadIndex%12 + 1;
        //    // cc.log("index :" + index);
        //    if(this.manAnimation === null){
        //        this.manAnimation = new cc.Sprite("#princess" + index + ".png");
        //        this.manAnimation.x = 360, this.manAnimation.y = 710;
        //        this.manAnimation.setScale(1.2);
        //        this.addChild(this.manAnimation);
        //    }else{
        //        Utils.changeTexture(this.manAnimation, "princess" + index + ".png")
        //    }
        //    //sprite.runAction(action.repeatForever());
        //}.bind(this));
    },
    // 0.3秒 后开始启动加载
    onEnter: function ()
    {
        this._super();
        //this.addPetAction();
        this.load();
    },

    // 加载
    load:function()
    {
        var self = this;

        // 获取要加载的资源数组
        var res = [];
        for(var index = this.loadControl.loadIndex; index < this.loadControl.loadIndex + loadResCount; index++)
        {
            if(index <= this.loadControl.resources.length - 1)
            {
                res.push(this.loadControl.resources[index]);
            }
        }

        if(res.length <= 0)
        {
            this.loadControl.load();
            return;
        }

        cc.loader.load(res,
            function (result, count, loadedCount)
            {
                self.loadControl.loadIndex++;
                self.addPetAction();
                self.showLoad();
            },
            function()
            {
                for(var key = 0; key < res.length; key++)
                {
                    if(cc.loader.getRes(res[key]) == null)
                    {
                        printLog("资源加载失败" + res[key]);
                        // 游戏断线后需要重新连接
                        var drawRect = new cc.DrawNode();
                        drawRect.drawRect(cc.p(0, 0), cc.p(gameWidth, 200), cc.color(0, 0, 0, 180));
                        drawRect.y = gameHigh / 2 - 100;
                        self.addChild(drawRect);
                        var lbConnected = new cc.LabelTTF(connectedTxt, defaultTxt, 24);
                        lbConnected.x = gameWidth / 2;
                        lbConnected.y = gameHigh / 2;
                        self.addChild(lbConnected);
                        self.label.setVisible(false);
                        engine.gameEvent.createMouseDown(self,
                            function(){
                                if(self.label.isVisible() == false)
                                {
                                    lbConnected.setVisible(false);
                                    drawRect.setVisible(false);
                                    self.label.setVisible(true);

                                    // 加载失败重新调用加载
                                    self.scheduleOnce(
                                        function()
                                        {
                                            loaderRes(self.loadControl.originalResources,
                                                      self.loadControl.cb,
                                                      self.loadControl.loadClassName,
                                                      self.loadControl.analysisFun
                                                     );
                                        }
                                        , 0.5);
                                }
                            });
                        return;
                    }
                }

                self.load();
            });
    },

    setLoadStyle:function()
    {
        //var self = this;
        //
        // 加载进度文字
        //this.label = new cc.LabelTTF("Loading... 0%", "Arial", 24);
        //this.label = new cc.LabelTTF("Loading...", defaultTxt, 24);
        //this.label.setPosition(cc.visibleRect.center);
        //this.label.setColor(cc.color(180, 180, 180));
        //this.addChild(this.label, 100);

        var bg=new cc.Sprite("res/loading/loadingbg.jpg");
        bg.setAnchorPoint(cc.p(0.5,0.5));
        bg.setPosition(cc.visibleRect.center);
        this.addChild(bg, 100);



        var barbg=new cc.Sprite("res/loading/loadingbarbg.png");
        barbg.setAnchorPoint(cc.p(0.5,0.5));
        barbg.setPosition(cc.visibleRect.center.x,cc.visibleRect.center.y-520);
        this.addChild(barbg, 100);


        //var bar_1=new cc.Sprite("res/loading/loadingbarbg.png");
        //bar_1.setAnchorPoint(cc.p(0.5,0.5));
        //bar_1.setPosition(cc.visibleRect.center.x-207,cc.visibleRect.center.y-520);
        //this.addChild(bar_1, 100);

        var bar_1=new cc.Sprite("res/loading/loadingbar_1.png");
        bar_1.setAnchorPoint(cc.p(0.5,0.5));
        bar_1.setPosition(cc.visibleRect.center.x-242,cc.visibleRect.center.y-520);
        this.addChild(bar_1, 100);


         this.bar=new cc.Sprite("res/loading/loadingbar_2.png");
        this.bar.setAnchorPoint(cc.p(0,0.5));
        this.bar.setPosition(cc.visibleRect.center.x-240,cc.visibleRect.center.y-520);
        this.addChild(this.bar, 100);

        this.bar_tou=new cc.Sprite("res/loading/loadingbar_1.png");
        this.bar_tou.setAnchorPoint(cc.p(0.5,0.5));
        this.bar_tou.setPosition(cc.visibleRect.center.x-235,cc.visibleRect.center.y-520);
        this.addChild(this.bar_tou, 100);



    },

    // 加载更新显示
    showLoad:function()
    {
        var percent = (this.loadControl.loadIndex / this.loadControl.resources.length)*(485/5);
        this.bar.setScaleX(percent);

        var pso=percent*5+cc.visibleRect.center.x-235;
        this.bar_tou.setPositionX(pso);

        //var percent = (this.loadControl.loadIndex / this.loadControl.resources.length * 100) | 0;
        //percent = Math.min(percent, 100);
        //this.label.setString("Loading... " + percent + "%");
    }
});

var loaderRes = function (resources, cb, loadClassName, analysisFun)
{
    var data = new Object();
    data.resources = resources;
    data.cb = cb;
    data.analysisFun = analysisFun;
    data.loadClassName = loadClassName;
    var loadControl = new LoadControl()
    loadControl.initialize(data);
};