/**
 * Created by Administrator on 2016/5/13.
 */
var middleEffect = 1;
var topEffect = 2;
var bottomEffect = 3;

// 技能管理类
var GameSkillManage = cc.Class.extend({

    // 是否初始化
    isInit: null,
    // 添加特效的容器
    effectContainer:null,
    // 技能数组
    skills:null,
    // 计算公式
    fightingComputeFun:null,

    ctor: function ()
    {
        this.isInit = false;
    },

    initialize: function()
    {
        if (this.isInit == true)
        {
            return;
        }

        this.skills = [];
    },

    cleanSkill:function()
    {
        this.skills = [];
    },

    addSkill:function(skill)
    {
        this.skills.push(skill);
    },

    addEffect:function(effect)
    {
        this.effectContainer.addChild(effect);
    },

    setEffectContainer:function(container)
    {
        this.effectContainer = container;
    },

    run:function()
    {
        if(engine.gameTime.isPause)
        {
            return;
        }

        // 技能心跳
        for(var n = this.skills.length - 1; n >= 0; n--)
        {
            this.skills[n].update();
            if(this.skills[n].isEnd == true)
            {
                this.skills.splice(n, 1);
            }
        }
    },

    // 技能计算
    fightingCompute:function(data)
    {
        if(this.fightingComputeFun != null)
        {
            this.fightingComputeFun(data);
        }
    }
})
