/**
 * Created by Administrator on 2016/5/6.
 */
var GamePool = cc.Class.extend({

    // 是否初始化
    isInit: null,

    ctor:function()
    {
        this.isInit = false;
    },

    initialize:function()
    {
        if (this.isInit == true)
        {
            return;
        }

        this.isInit = true;
    },

    initObjPool:function(className, count)
    {
        var objs = [];
        for(var i = count - 1;i >= 0;i--)
        {
            var poolObj = new className();
            objs.push(poolObj);
            cc.pool.putInPool(poolObj);
        }

        return objs;
    },

    popOut:function(className)
    {
        var obj = cc.pool.getFromPool(className);
        if(obj == null)
        {
            obj = new className();
        }
        return obj;
    },

    putInPool:function(obj)
    {
        cc.pool.putInPool(obj);
    },

    hasObject:function(obj)
    {
        return cc.pool.hasObject(obj);
    },

    clearObject:function(obj)
    {
        cc.pool.removeObject(obj);
    },

    clearPool:function()
    {
        cc.pool.drainAllPools();
    }
});

