
var ShopLayer=cc.Layer.extend({
    ctor: function(){
        this._super();
    },
    onEnter: function(){
        this._super();
        this.initUI();
        this.initListener();
    },
    initUI: function(){
        this.mainUI = loadCSS(res.res_game_shop_json);
        this.addChild(this.mainUI);

        this.mainUI.vedioCount.setString(""+gameUserData.googleVCount);
        if(gameUserData.googleVCount==0){
            this.mainUI.itembtn_1.setColor(cc.color(100,100,100,200));
        }
    },
    initListener:function(){
        engine.gameEvent.createMouseUp(this.mainUI.closebtn, this.onClose.bind(this), buttonScalingType);
        engine.gameEvent.createMouseUp(this.mainUI.itembtn_1, this.Pay_1.bind(this), buttonScalingType);
        engine.gameEvent.createMouseUp(this.mainUI.itembtn_2, this.Pay_2.bind(this), buttonScalingType);
        engine.gameEvent.createMouseUp(this.mainUI.itembtn_3, this.Pay_3.bind(this), buttonScalingType);
        engine.gameEvent.createMouseUp(this.mainUI.itembtn_4, this.Pay_4.bind(this), buttonScalingType);
        engine.gameEvent.createMouseUp(this.mainUI.itembtn_5, this.Pay_5.bind(this), buttonScalingType);
        engine.gameEvent.createMouseUp(this.mainUI.itembtn_6, this.Pay_6.bind(this), buttonScalingType);

        Event.register(EVENT_ID.GOOGLEPAYVEDIO, function(){
            gameUserData.googleVCount--;
            this.mainUI.vedioCount.setString(""+gameUserData.googleVCount);
            if(gameUserData.googleVCount==0){
                this.mainUI.itembtn_1.setColor(cc.color(100,100,100,200));
            }
            saveUserData();
        }, this);
    },
    onClose: function(){
        SoundMgr.playEffect(soundRes.sound_btn);
        this.removeFromParent();
    },
    Pay_1: function(){
        if(gameUserData.googleVCount==0){
            return;
        }
        SoundMgr.playEffect(soundRes.sound_btn);
        googlePayItem(100);
    },
    Pay_2: function(){
        SoundMgr.playEffect(soundRes.sound_btn);
        googlePayItem(1);
    },
    Pay_3: function(){
        SoundMgr.playEffect(soundRes.sound_btn);
        googlePayItem(2);
    },
    Pay_4: function(){
        SoundMgr.playEffect(soundRes.sound_btn);
        googlePayItem(3);
    },
    Pay_5: function(){
        SoundMgr.playEffect(soundRes.sound_btn);
        googlePayItem(4);
    },
    Pay_6: function(){
        SoundMgr.playEffect(soundRes.sound_btn);
        googlePayItem(5);
    },
    onExit: function(){
        this._super();
        Event.remove(EVENT_ID.GOOGLEPAYVEDIO,this);
    },

});