
var SoundMgr =  {
    isOpen: true,    // 是否开启声音
    id: 0, // 音效id
    // 播放音乐
    playMusic: function(name, isRepeat){
        //name = getUrlByVersion(name);
        if(!this.isOpen){ return ;}
        isRepeat = isRepeat || false;
        cc.audioEngine.playMusic(name, isRepeat)
    },
    // 暂停音乐
    pauseMusic: function(){
        if(!this.isOpen){ return ;}
        cc.audioEngine.pauseMusic();
    },
    // 是否播放音乐
    isMusicPlaying: function(){
        if(!this.isOpen){ return ;}
        if(cc.audioEngine.isMusicPlaying()){
            return true;
        } else {
            return false;
        }
    },
    // 停止音乐
    stopMusic: function(isRelease){
        isRelease = isRelease || false;
        cc.audioEngine.stopMusic(isRelease);
    },
    // 播放音效
    playEffect: function(name, isRepeat){
        //name = getUrlByVersion(name);
        isRepeat = isRepeat || false;
        if(!this.isOpen){ return ;}
        var id = cc.audioEngine.playEffect(name, isRepeat);
        return id;
    },
    // 停止音效
    stopEffect: function(id){
        cc.audioEngine.stopEffect(id);
    },
    // 停止所有音效
    stopAllEffects: function(){
        cc.audioEngine.stopAllEffects();
    },
    // 暂停音效
    pauseEffect: function(id){
        cc.audioEngine.pauseEffect(id);
    },
    // 重启音效
    resumeEffect: function(id){
        cc.audioEngine.resumeEffect(id);
    }

};