
var GameRolesConfig = [
    {id:1000,icon:"item/question.png", zh:"随机选择"},
    {id:1001,price: 100, speedX:385,upG:4500,downG:5700,h:120,pos1:{x:77,y:90},pos2:{x:6,y:90}, upImg:"role/princess_up.png", downImg:"role/princess_down.png", zh:"公主",en:"Princess",fr:"Princesse"},
    {id:1002,price: 200, speedX:390,upG:5700,downG:4700,h:120,pos1:{x:50,y:90},pos2:{x:6,y:90}, upImg:"role/ninja_up.png", downImg:"role/ninja_down_down.png", zh:"忍者",en:"Ninja",fr:"Ninja"},
    {id:1003,price: 300, speedX:385,upG:5200,downG:5700,h:120,pos1:{x:56,y:96},pos2:{x:-6,y:93}, upImg:"role/captain_up.png", downImg:"role/captain_down.png", zh:"约翰",en:"John",fr:"John"},
    {id:1004,price: 400, speedX:380,upG:4300,downG:5200,h:120,pos1:{x:60,y:91},pos2:{x:-1,y:91}, upImg:"role/worker_down.png", downImg:"role/worker_up.png", zh:"上班族",en:"Office worker",fr:"Homme d'affaires"},
    {id:1005,price: 500, speedX:370,upG:5200,downG:5500,h:120,pos1:{x:56,y:82},pos2:{x:-9,y:82}, upImg:"role/skeleton_up.png", downImg:"role/skeleton_down.png", zh:"骷髅",en:"Skeleton",fr:"Squelette"},
    {id:1006,price: 600, speedX:350,upG:4200,downG:3700,h:120,pos1:{x:90,y:92},pos2:{x:18,y:92}, upImg:"role/robot_up.png", downImg:"role/robot_down.png", zh:"机器人",en:"Robot",fr:"Robot"},
    {id:1007,price: 700, speedX:340,upG:1200,downG:1700,h:120,pos1:{x:60,y:93},pos2:{x:-5,y:93}, upImg:"role/spaceman_up.png", downImg:"role/spaceman_down.png", zh:"宇航员",en:"Astronaut",fr:"Astronaute"}
];
var GameSceneConfig = [
    {id:2000,icon:"item/question.png", zh:"随机选择"},
    {id:2001,price: 100, size:{w:1738, h:2811}, folder: "map_bg", icon: "item/icon2.png", mapFloor: "bg/bg1.png", zh:"现代都市",en:"Modern City"},
    {id:2002,price: 200, size:{w:1839, h:2917}, folder: "sakura", icon: "item/icon4.png", mapFloor: "bg/bg2.png",  zh:"樱花古都",en:"Cherry City"},
    {id:2003,price: 300, size:{w:3004, h:2826}, folder: "egypt", icon: "item/icon1.png", mapFloor: "bg/bg3.png",  zh:"埃及",en:"Egypt"},
    {id:2004,price: 400, size:{w:1419, h:2408}, folder: "russia", icon: "item/icon3.png", mapFloor: "bg/bg4.png",  zh:"俄罗斯",en:"Russia"},
    {id:2005,price: 500, size:{w:1276, h:2478}, folder: "venice", icon: "item/icon5.png", mapFloor: "bg/bg5.png",  zh:"威尼斯",en:"Venice"}
];
// 天空颜色
var SkyColorConfig = [
    [191,247,254,  181,240,248,  169,230,242,  84,114,148,  11,19,38],
    [193,252,242,  170,245,240,  138,197,208,  100,151,154,  42,57,66],
    [183,245,230,  162,234,223,  145,195,235,   61,108,118,  10,28,38],
    [192,248,254,  164,224,241,  142,192,232,  102,138,171,  12,20,40],
    [255,239,174,  245,235,141,  212,151,104,  212,151,104,  38,20,14]
];
// 解锁场景条件
var UnlockSceneCondition = [
    {curId:2001,unlockID:2002,floor:100},
    {curId:2002,unlockID:2003,floor:150},
    {curId:2003,unlockID:2004,floor:200},
    {curId:2004,unlockID:2005,floor:250}
];

/* type 1 代表 达到层数 2 角色数量 3 场景数量
 condition 任务条件
 */
var TaskConfig = [
    {"id": 1, "type": 1, "condition": 50, "reward": 10, "zh": "首次达到50层",en:"Reach the 50 floor for the first time."},
    {"id": 2, "type": 1, "condition": 100, "reward": 20., "zh": "首次达到100层",en:"Reach the 100 floor for the first time."},
    {"id": 3, "type": 1, "condition": 150, "reward": 30 , "zh": "首次达到150层",en:"Reach the 150 floor for the first time."},
    {"id": 4, "type": 1, "condition": 200, "reward": 50, "zh": "首次达到200层",en:"Reach the 200 floor for the first time."},
    {"id": 5, "type": 2, "condition": 3, "reward": 10, "zh": "拥有3个角色",en:"Unlock the role 3"},
    {"id": 6, "type": 2, "condition": 5, "reward": 20, "zh": "拥有5个角色",en:"Unlock the role 5"},
    {"id": 7, "type": 2, "condition": 6, "reward": 30, "zh": "拥有6个角色",en:"Unlock the role 6"},
    {"id": 8, "type": 2, "condition": 7, "reward": 50, "zh": "拥有7个角色",en:"Unlock the role 7"},
    {"id": 9, "type": 3, "condition": 3, "reward": 30, "zh": "解锁3个场景",en:"Unlock the scene 3"},
    {"id": 10, "type": 3, "condition": 4, "reward": 40, "zh": "解锁4个场景",en:"Unlock the scene 4"},
    {"id": 11, "type": 3, "condition": 5, "reward": 50, "zh": "解锁5个场景",en:"Unlock the scene 5"}
];
var TaskExtraConfig = [
    {"id": 1, "type": 1, "condition": 50, "reward": 10, "zh": "首次达到50层",en:"Reach the 50 floor for the first time."},
    {"id": 2, "type": 1, "condition": 100, "reward": 20., "zh": "首次达到100层",en:"Reach the 100 floor for the first time."},
    {"id": 3, "type": 1, "condition": 150, "reward": 30 , "zh": "首次达到150层",en:"Reach the 150 floor for the first time."},
    {"id": 4, "type": 1, "condition": 200, "reward": 50, "zh": "首次达到200层",en:"Reach the 200 floor for the first time."},
    {"id": 5, "type": 1, "condition": 250, "reward": 60, "zh": "首次达到250层",en:"Reach the 250 floor for the first time."},
    {"id": 6, "type": 1, "condition": 300, "reward": 70., "zh": "首次达到300层",en:"Reach the 300 floor for the first time."},
    {"id": 7, "type": 1, "condition": 400, "reward": 80 , "zh": "首次达到400层",en:"Reach the 400 floor for the first time."},
    {"id": 8, "type": 1, "condition": 500, "reward": 90, "zh": "首次达到500层",en:"Reach the 500 floor for the first time."},
    {"id": 9, "type": 2, "condition": 3, "reward": 10, "zh": "拥有3个角色",en:"Unlock the role 3"},
    {"id": 10, "type": 2, "condition": 5, "reward": 20, "zh": "拥有5个角色",en:"Unlock the role 5"},
    {"id": 11, "type": 2, "condition": 6, "reward": 30, "zh": "拥有6个角色",en:"Unlock the role 6"},
    {"id": 12, "type": 2, "condition": 7, "reward": 50, "zh": "拥有7个角色",en:"Unlock the role 7"},
    {"id": 13, "type": 3, "condition": 3, "reward": 30, "zh": "解锁3个场景",en:"Unlock the scene 3"},
    {"id": 14, "type": 3, "condition": 4, "reward": 40, "zh": "解锁4个场景",en:"Unlock the scene 4"},
    {"id": 15, "type": 3, "condition": 5, "reward": 50, "zh": "解锁5个场景",en:"Unlock the scene 5"}
];

var Global = Global || {};
Global.language = "en";
Global.isPure = true; // 是否是纯净版
Global.curLevel = 1;  // 当前的层数
Global.curGold = 0;   // 本局获得的金币
Global.maps = [1011, 1012,0];    // 关卡
Global.pause = false;   // 暂停游戏
Global.mapMoveDistance = 100;   // 地图移动距离
Global.messagePrice = 150;      // 获取信封的价格
Global.replayNum = 0;           // 重玩的次数
Global.historyLevel = 0;        // 重玩时的层数
Global.starLevel = 140;          // 星星开始出现的层数
Global.cloudLevel = 70;          // 云出现层数

Global.skyMoveSpeed = 100;     // 天空移动速度
Global.bgMoveSpeed = 300;      // 背景移动速度
Global.resurgenceLevel = 9;    // 复活的楼层
Global.isFisrtEnter = true;    // 第一次进游戏

Global.rePlayCount = 1;    // 重玩游戏

Global.unlockNextSceneText = {  // 解锁下一个场景
    pre:{zh:"达到 ",en:"Reach the "},
    middle:{zh:" 层解锁",en:" floor to unlock"},
    end:{zh:"免费",en:"for free"}
};
Global.mapID = { // 地图ID
  type1:[[1011, 1012, 1013] ,[1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029], [1031, 1032, 1033]],
  type2:[[2011, 2012, 2013], [2021, 2022, 2023], [2031, 2032, 2033]],
  type3:[[3011, 3012, 3013], [3021, 3022, 3023], [3031, 3032, 3033]],
  type4:[[4011, 4012, 4013], [4021, 4022, 4023, 4024], [4031, 4032, 4033]]
};
Global.hards = [50, 100];     // 关卡到100 中等难度，200 最难
/*
* level 关卡 num 产生金币的数量
* */
Global.goldNums = [
    {level: 50, num: 1},
    {level: 250, num: 2},
    {level: 400, num: 3}
];
//  name 图片名字， isShow 是否显示后面的背景
Global.decorates = [
    {name:"chair", isShow: 0},
    {name:"chest", isShow: 0},
    {name:"computer_table", isShow: 0},
    {name:"lift", isShow: 0},
    {name:"long_sofa", isShow: 0},
    {name:"pot1", isShow: 0},
    {name:"pot2", isShow: 0},
    {name:"pot3", isShow: 0},
    {name:"short_sofa", isShow: 0},
    {name:"window_close", isShow: 1},
    {name:"window_half_open", isShow: 1},
    {name:"window_open", isShow: 1},

    {name:"window_half_open", isShow: 1},
    {name:"window_open", isShow: 1},
    {name:"window_half_open", isShow: 1},
    {name:"window_open", isShow: 1}
];

/* h 表示 跳跃一次 地图纵向移动的高度 w: 大于0 右移动 小于0左移动 具体移动多少是程序自己算的
*/
Global.Map = [
    {id:1,h:130,w:0}
];
