
/**
 * Created by Administrator on 2016/8/17.
 */
var artWordNo = 0;
var artWordMiddle = 1;
var artWordLeft = 2;
var artWordRight = 3;

var GameArtWord = cc.Sprite.extend({

    // 文本
    text:null,
    //字符的宽度
    txtWidth:null,
    //字符的高度
    txtHeight:null,
    // 字体名称
    fontName:null,
    // 对齐方式
    alignmentType:null,
    // 内容
    contentSprite:null,

    ctor: function ()
    {
        this.alignmentType = artWordNo;
        this._super();
    },

    setString:function(strText)
    {
        if(strText == this.text)
        {
            return;
        }

        if(this.contentSprite == null)
        {
            this.contentSprite = new cc.Sprite();
            this.addChild(this.contentSprite);
        }
        else
        {
            this.contentSprite.removeAllChildren();
        }

        this.text = strText;

        var x = 0;
        for(var i = 0; i < strText.length; i++)
        {
            var character = strText[i];
            if(escapeTxt[character] != null)
            {
                character = escapeTxt[character];
            }
            var charSprite = new cc.Sprite("#fnt/" + this.fontName + "_" + character + ".png");
            charSprite.x = x;
            if(character == "1")
            {
                x = x + this.txtWidth - 1;
            }
            else
            {
                x = x + this.txtWidth;
            }
            this.contentSprite.addChild(charSprite);
        }

        switch(this.alignmentType)
        {
            case artWordMiddle:
                this.contentSprite.x = -x / 2;
                break;
            case artWordLeft:
                this.contentSprite.x = 0;
                break;
            case artWordRight:
                this.artWordRight.x = x;
                break;
        }

    }
});

var creatGameArtWord = function(txtWidth, txtHeight, fontName)
{
    var gameArtWord = new GameArtWord();
    gameArtWord.txtWidth = txtWidth;
    gameArtWord.txtHeight = txtHeight;
    gameArtWord.fontName = fontName;
    return gameArtWord;
}