/**
 * Created by Administrator on 2016/8/17.
 */
var GameLabelAtlasText = cc.Sprite.extend({

     // 文本
    text:null,
    // 图片上的文字
    imgString:null,
    //字符的宽度
    txtWidth:null,
    //字符的高度
    txtHeight:null,
    // 字符索引的集合
    strIndexDic:null,
    // 图片纹理
    textureList:null,

    onEnter:function()
    {
        this._super();
    },

    createLabelAtlasText:function()
    {
        for(var index = 0; index < this.imgString.length; index++)
        {
            this.strIndexDic[this.imgString[index]] = index;
        }
    },

    setString:function(strText)
    {
        if(strText == this.text)
        {
            return;
        }
        this.removeAllChildren();
        this.text = strText;

        this.setContentSize(cc.size(this.txtWidth * strText.length, this.txtHeight));

        for(var i = 0; i < strText.length; i++)
        {
            var index = this.strIndexDic[strText[i]];
            var charSprite = new cc.Sprite(this.textureList, cc.rect(index * this.txtWidth, 0, this.txtWidth, this.txtHeight));
            charSprite.attr({x:i * this.txtWidth, y:0, anchorX:0, anchorY:1});
            this.addChild(charSprite);
        }
    }
});

var creatGameLabelAtlasText = function(txtWidth, txtHeight, imgString, texture)
{
    var gameLabelAtlasText = new GameLabelAtlasText();
    gameLabelAtlasText.txtWidth = txtWidth;
    gameLabelAtlasText.txtHeight = txtHeight;
    gameLabelAtlasText.imgString = imgString;
    gameLabelAtlasText.textureList = cc.textureCache.addImage(texture);
    gameLabelAtlasText.text = "";
    gameLabelAtlasText.strIndexDic = new Object();
    gameLabelAtlasText.createLabelAtlasText();
    return gameLabelAtlasText;
}