var ThunderSkillType = 1;
var LinearShotgunSkillType = 2;
var LaserSkillType = 3;
var GardenRoundSkillType = 4;
var BulletSkillType = 5;

var Skill = cc.Class.extend
({
    // 攻击者信息
    sendID:null,
    sendType:null,

    // 打击目标信息
    targetList:null,
    // 战斗信息
    attackInfo:null,
    // 技能是否执行完毕
    isEnd:null,
    // 包含特效键值
    skillEffectDic:null,

    // 打击人物信息
    hitInfo:null,
    // 技能类型
    skillType:null,

    ctor: function ()
    {
        this.targetList = [];
        this.isEnd = false;
        this.hitInfo = new Object();
    },

    initialize:function(data)
    {
        this.targetList = data.targetList;
        this.attackInfo = data.attackInfo;
        this.sendID = data.sendID;
        this.sendType = data.sendType;
        this.skillEffectDic = data.skillEffectDic;
    },

    update:function()
    {

    },

    // 执行技能
    run:function()
    {

    },

    onEnter:function()
    {
        this._super();
    },

    // 添加打击特效
    addHitEffect:function(target, effectID, addType)
    {
        // 没死亡身上会有特效
        if(target.hp > 0)
        {
            if(this.skillEffectDic[effectID] != 0)
            {
                var effect = createAnimation();
                var data = new Object();
                data.animationid = this.skillEffectDic[effectID];
                data.animationtype = "free";
                data.isRemoveFromComplete = true;
                data.playCount = 1;
                effect.initialize(data);
                target.addEffect(effect, addType);
            }
        }
    },

    // 设置打击的键值
    setHitAnimalKey:function(key)
    {
        this.hitInfo[key] = true;
    },

    // 获取是否可以打击了
    isCanHitAnimal:function(key)
    {
        if(this.hitInfo[key] == null)
        {
            return true;
        }
        return false;
    },

    dispose:function()
    {

    }
})