// sdk 控制
var SDKControl  = {
    // 添加sdk 界面
    addSDKView: function(ui){
        if(!gameUserData.isLockState){
            this.addActivateUI(ui);
        } else {
            this.addShopUI(ui);
        }
    },
    // 添加激活界面
    addActivateUI: function(ui){
        var layer = new SDK_Dialog(SDK_TYPE.OCC, gSdkData.unLockDes, 1);
        createMaskLayer(layer);
        ui.addChild(layer, 1001);
    },
    // 添加shop 界面
    addShopUI: function(ui){
        var layer = new SDKLayer();
        createMaskLayer(layer);
        ui.addChild(layer, 1001);
    },
    // 购买商品
    payItemWithMoney: function(id, ui){
        var layer = new SDK_Dialog(SDK_TYPE.OCC, gSdkData.itemWaitDes[id - 1], id);
        createMaskLayer(layer);
        layer.dialog_type = 1;
        ui.addChild(layer, 1001);
        layer.payMoneyDes(id);
    },
    // +按钮是否显示
    isShowAddBtn: function(){
        if(Global.isPure || !gameUserData.isLockState || !gSdkData.isShowShop){
            return false
        }
        return true;
    }
};
